"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const test_case_runner_1 = __importDefault(require("@cucumber/cucumber/lib/runtime/test_case_runner"));
const messages_1 = require("@cucumber/messages");
const originIsSkippingSteps = test_case_runner_1.default.prototype.isSkippingSteps;
// patch isSkippingStep method
test_case_runner_1.default.prototype.isSkippingSteps = function () {
    // @ts-ignore
    const pickle = this.pickle;
    // @ts-ignore
    const testStepResults = this.testStepResults;
    // @ts-ignore
    const testCase = this.testCase;
    // @ts-ignore
    const currentTestStepId = this.currentTestStepId;
    const activationTag = global?.config?.softAssertTag ?? '@softAssert';
    const isSoftAssertEnabled = pickle.tags.find((tag) => tag.name === activationTag);
    if (!isSoftAssertEnabled) {
        return originIsSkippingSteps.apply(this);
    }
    const testStepResultsTypes = testStepResults.map((result, i) => {
        const testStep = testCase.testSteps[i];
        const pickleStep = pickle.steps.find((step) => step.id === testStep?.pickleStepId);
        return { status: result.status, type: pickleStep?.type };
    });
    const isNotOutcomeFailed = testStepResultsTypes.find((result) => result.status !== messages_1.TestStepResultStatus.PASSED && result.type !== messages_1.StepKeywordType.OUTCOME);
    const currentTestStep = testCase.testSteps.find((step) => step.id === currentTestStepId);
    const currentPickleStep = pickle.steps.find((step) => step.id === currentTestStep?.pickleStepId);
    const isCurrentStepOutcome = currentPickleStep?.type === messages_1.StepKeywordType.OUTCOME;
    if (isCurrentStepOutcome && !isNotOutcomeFailed) {
        return false;
    }
    return originIsSkippingSteps.apply(this);
};
//# sourceMappingURL=index.js.map